//+------------------------------------------------------------------+
//|                                             Qbot-v0.3.2-beta.mq4 |
//|                            Copyright  2007, Matthew Ebersviller |
//|                                               version 0.3.2-beta |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Matthew Ebersviller"
#property link "http://www.forex-tsd.com/expert-advisors-metatrader-4/10266-ea-request-profitable-gbp-jpy-system.html"

/*********************************************************************
* This EA is based upon the rules posted by Lepiricus in a forum at  *
* Forex-TSD.com.  It utilized the QQE indicator posted by lepiricus. *
* I do not know who to credit for the QQE indicator, but I know it   *
* was not created by myself, Matthew Ebersviller.  I take no credit  *
* (or responsibility) for the EA logic.                              *
*                                                                    *
* The EA works on Crossovers of the QQE on the 30 and 60 minute time *
* frames.  If you want to know more, read the messages at the forum. *
* The messages are at the URL in the link property of this EA.       *
*                                                                    *
* On your charts:                                                    *
*   +Green arrows are Buy entry points                               *
*   +Red arrows are Sell entry points                                *
*   +Violet arrows are trades closed by QQE changes                  *
*   +Yellow arrows are trades closed by trailing stoploss            *
*   +I don't know what (if any) color arrow is a take profit or      *
*    fixed stop loss                                                 *
*********************************************************************/

extern int SL = 100;
extern int TP = 150;
extern bool UseMoneyManagement = True;
extern double MinLots = 0.1;
extern bool TrailingStop = True;
extern int Slippage = 3;
extern int shortTF = 30;
extern int longTF = 60;
extern double MaximumRisk = 0.02;
extern int MagicNumber = 1000;
extern int SF = 5;

bool NoOpen = false;
double stopLevel = 0.0;
double Lots;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   Lots = MinLots;
   return(0); 
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
  return(0);  // I see no need for any deinit in this EA, but I included
              // it for completeness
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   double qqeSTF0, qqeSTF1, qqeLTF0, qqeLTF1;
   int total, ticket, count;
   stopLevel = 0.0;
   qqeSTF0 = iCustom(NULL,shortTF,"QQE",SF,0,1);
   qqeSTF1 = iCustom(NULL,shortTF,"QQE",SF,1,1);
   qqeLTF0 = iCustom(NULL,longTF,"QQE",SF,0,1);
   qqeLTF1 = iCustom(NULL,longTF,"QQE",SF,1,1);
   total = OrdersTotal();
   Lots = LotsOptimized();   
   checkForExits(total, count, qqeSTF0, qqeSTF1, qqeLTF0, qqeLTF1);
   checkForEntries(total, ticket, qqeSTF0, qqeSTF1, qqeLTF0, qqeLTF1);
   checkForNoOpenChange();
   //Comment("Stoplevel is currently ",stopLevel);

   return(0);
}

//
// End of EA logic
//


////////////////////////////////////
// Custom Functions Defined Below //
////////////////////////////////////

void checkForEntries(int total, int ticket, double qqeSTF0, double qqeSTF1, double qqeLTF0, double qqeLTF1) {
     // If there are no open orders...
   if (total < 1 && NoOpen==false) {
      // If we have enough money...
      if(AccountFreeMargin()<(1000*Lots)) {
         Print("No money left. Free Margin = ", AccountFreeMargin());
         return(0);  
       }
      // Is there a buy opportunity? 
      if ((qqeSTF0 > qqeSTF1) && (qqeLTF0 > qqeLTF1)) {
                
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-SL*Point,Ask+TP*Point,"Qbot v0.3.2-beta",MagicNumber,0,Green);
         if(ticket>0) {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
            NoOpen = True;
         }
         else {
            Print("Error opening BUY order : ",GetLastError()); 
            NoOpen = False;
         }
         return(0); 
      }
            // Is there a sell opportunity? 
     if ((qqeSTF0 < qqeSTF1) && (qqeLTF0 < qqeLTF1)) {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+SL*Point,Bid-TP*Point,"Qbot v0.3.2-beta",MagicNumber,0,Red);
         if(ticket>0) {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
            NoOpen = True;
         }
         else {
            Print("Error opening SELL order : ",GetLastError()); 
            NoOpen = False;
         }
         return(0); 
      }     

   }
}

void checkForExits(int total, int count, double qqeSTF0, double qqeSTF1, double qqeLTF0, double qqeLTF1) {
  for(count=0;count<total;count++) {
     OrderSelect(count, SELECT_BY_POS, MODE_TRADES);
     if ((OrderType()<=OP_SELL) && (OrderSymbol()==Symbol())) {  // check for open position
        if (OrderType()==OP_BUY) {   // long position is opened
           // should it be closed?
           if ((qqeSTF0 < qqeSTF1) || (qqeLTF0 < qqeLTF1)) {
                OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet); // close position
                NoOpen = False;
                //return(0);
            }
           // check for trailing stop (long)
           stopLevel = checkTrailingStopLevels("buy");
           if(TrailingStop) {                 
              if (OrderOpenPrice() <= stopLevel) {
                 OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet);
                 NoOpen = True;
              }
            }
         }
        else { // go to short position
           // should it be closed?
           
           if((qqeSTF0 > qqeSTF1) || (qqeLTF0 > qqeLTF1)) {
              OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet); // close position
              //return(0);
           }
           // check for trailing stop (short)
           stopLevel = checkTrailingStopLevels("sell");
           if(TrailingStop) {                 
              if(OrderOpenPrice() >= stopLevel) {
                 OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet);
                 NoOpen = True;
              }
           }
        }
     }
  }
}

void checkForNoOpenChange() {
        
  if ( ((iCustom(NULL,shortTF,"QQE",SF,0,2) <= iCustom(NULL,shortTF,"QQE",SF,1,2)) && (iCustom(NULL,shortTF,"QQE",SF,0,1) > iCustom(NULL,shortTF,"QQE",SF,1,1))   ) || 
       ((iCustom(NULL,longTF,"QQE",SF,0,2) <= iCustom(NULL,longTF,"QQE",SF,1,2)) && (iCustom(NULL,longTF,"QQE",SF,0,1) > iCustom(NULL,longTF,"QQE",SF,1,1))) ) {
       NoOpen=false;
  }
  
    if ( ((iCustom(NULL,shortTF,"QQE",SF,0,2) >= iCustom(NULL,shortTF,"QQE",SF,1,2)) && (iCustom(NULL,shortTF,"QQE",SF,0,1) < iCustom(NULL,shortTF,"QQE",SF,1,1))   ) || 
       ((iCustom(NULL,longTF,"QQE",SF,0,2) >= iCustom(NULL,longTF,"QQE",SF,1,2)) && (iCustom(NULL,longTF,"QQE",SF,0,1) < iCustom(NULL,longTF,"QQE",SF,1,1))) ) {
       NoOpen=false;
  }
}
     
double checkTrailingStopLevels(string orderType) {
   if (orderType == "buy") {
      if (TrailingStop) {
         if (Bid-OrderOpenPrice()>SL*Point) {
            //if (stopLevel<Bid-Point*SL) {
               stopLevel = Bid-SL*Point;
            //}
         }
      }
   }
   
   if (orderType == "sell") {
      if (TrailingStop) {
         if (Ask+OrderOpenPrice()>SL*Point) {
            //if (stopLevel<Ask+Point*SL) {
               stopLevel = Ask+SL*Point;
            //}
         }
      }
   }
 
   return(stopLevel);
}

//This EA was copied directly from the sample EA, "Moving Average"
//that accompanies every MT4 install.
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
   if(lot<0.1) lot=0.1;
   return(lot);
  }